//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <cassert>
#include <iostream>

class stack
{
	public:
		stack();
		void push(const int& _value);
		void pop();
		int& top();
	private:
		int values[5]; // TODO Change size
		int index;
};
//-----------------------------------------------------------------------------
stack::stack():index(-1)
{
	
}
//-----------------------------------------------------------------------------
void stack::push(const T& _value)
{
	assert(index<Max);
	values[++index] = _value;
}
//-----------------------------------------------------------------------------
void stack::pop()
{
	assert(index>=0);
	--index;
}
//-----------------------------------------------------------------------------
int& stack::top()
{
	return values[index];
}

int main()
{
	// Stack de int
	stack si;
	si.push(1);
	si.push(2);
	si.push(3);
	int ti = si.top();
	si.pop();
	si.pop();
	si.pop();

	// Stack de float
	stack sf;
	sf.push(1.2f);
	sf.push(2.3f);
	sf.push(3.4f);
	float tf = sf.top();
	sf.pop();
	sf.pop();
	sf.pop();

	char c;
	std::cout << "Press any key, then enter...";
	std::cin >> c;
	return 0;
}
